diff --git a/gdraw/ggdkdraw.c b/gdraw/ggdkdraw.c
old mode 100644
new mode 100755
index fceeb65f6d..deeb058997
--- a/gdraw/ggdkdraw.c
+++ b/gdraw/ggdkdraw.c
@@ -592,7 +592,7 @@ static GWindow _GGDKDraw_CreateWindow(GGDKDisplay *gdisp, GGDKWindow gw, GRect *
             nw->is_dlg = true;
         } else if (!nw->is_dlg) {
             ++gdisp->top_window_count;
-        } else if (nw->restrict_input_to_me && gdisp->last_nontransient_window != NULL) {
+        } else if (nw->restrict_input_to_me && (gdisp->last_nontransient_window != NULL || gdisp->restrict_count > 0)) {
             GGDKDrawSetTransientFor((GWindow)nw, (GWindow) - 1);
         }
         nw->isverytransient = (wattrs->mask & wam_verytransient) ? 1 : 0;
@@ -1557,7 +1557,7 @@ static char *GGDKDrawGetWindowTitle8(GWindow gw) {
 
 static void GGDKDrawSetTransientFor(GWindow transient, GWindow owner) {
     Log(LOGDEBUG, " ");
-    GGDKWindow gw = (GGDKWindow) transient, ow;
+    GGDKWindow gw = (GGDKWindow) transient, ow = NULL;
     GGDKDisplay *gdisp = gw->display;
     assert(owner == NULL || gw->is_toplevel);
 
@@ -1566,7 +1566,21 @@ static void GGDKDrawSetTransientFor(GWindow transient, GWindow owner) {
     }
 
     if (owner == (GWindow) - 1) {
-        ow = gdisp->last_nontransient_window;
+        if (gdisp->restrict_count > 0) {
+            for (int i = ((int)gdisp->transient_stack->len) - 1; i >= 0; --i, ow = NULL) {
+                ow = (GGDKWindow) gdisp->transient_stack->pdata[i];
+                if (ow->restrict_input_to_me) {
+                    break;
+                }
+            }
+        }
+        if (ow == NULL) {
+            ow = gdisp->last_nontransient_window;
+        }
+        if (ow != NULL && ow != gdisp->last_nontransient_window) {
+            Log(LOGINFO, "Multiple input restrictions active; made transient to the last window with input restrictions (%p (%s) -> %p (%s))",
+                gw, gw->window_title, ow, ow->window_title);
+        }
     } else if (owner == NULL) {
         ow = NULL; // Does this work with GDK?
     } else {
